#ifndef _MATRIX_H_
#define _MATRIX_H_
#include "vector.h"

class Matrix {
  public:
    float x[4][4];

    Matrix() {};
    Matrix(float);

    Matrix& operator += (const Matrix&);
    Matrix& operator -= (const Matrix&);
    Matrix& operator *= (const Matrix&);
    Matrix& operator *= (float);
    Matrix& operator /= (float);

    friend Matrix operator + (const Matrix&, const Matrix&);
    friend Matrix operator - (const Matrix&, const Matrix&);
    friend Matrix operator * (const Matrix&, const Matrix&);
    friend Matrix operator * (const Matrix&, float);
    friend Vector operator * (const Matrix&, const Vector&);
};

Matrix Translate(const Vector&);
Matrix Scale(const Vector&);
Matrix RotateX(float);
Matrix RotateY(float);
Matrix RotateZ(float);
Matrix Rotate(const Vector&, float);
Matrix MinorX();
Matrix MinorY();
Matrix MinorZ();


#endif
