#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

int NUMSTARS = 1000;

struct TPoint {
  float x, y, inc_y, inc_x, color;
} stars[2000];

void SetMode(int mode)
{
  asm mov ax, mode
  asm int 10h
}

void SetRGB(unsigned char Color, unsigned char R, unsigned char G, unsigned char B)
{
  asm
  {
    mov  dx, 03C8h
    mov al, Color
    out  dx, al
    inc  dx
    mov  al, R
    out  dx, al
    mov  al, G
    out  dx, al
    mov  al, B
    out  dx, al
  }
}

void PutPixel(int x, int y, char color)
{
  asm
  {
    push es
    mov ax, 0A000h
    mov es, ax
    mov di, y
    shl di, 8
    mov bx, y
    shl bx, 6
    add di, bx
    add di, x
    mov al, color
    mov cx, 2
    rep stosb
    add di, 318
    mov cx, 2
    rep stosb
//    stosb
    pop es
  }
}

void InitStar(TPoint &t)
{
  do
  {
    t.x = random(300) + 20;
    t.y = random(190) + 10;
  } while ((t.x < 161 && t.x > 159) || (t.y < 101 && t.y > 99) || (t.x < 10 || t.x > 310) || (t.y < 10 || t.y > 190));
  t.color = 0;
  if (abs(t.x - 160) > abs(t.y - 100))
  {
    if (t.x < 160)
      t.inc_x = -1;
    else
      t.inc_x = 1;
    t.inc_y = (t.y - 100) / abs(t.x - 160);
  }
  else
  {
    if (t.y < 100)
      t.inc_y = -1;
    else
      t.inc_y = 1;
    t.inc_x = (t.x - 160) / abs(t.y - 100);
  }

//  if (t.x - 160)
//    t.inc_y = t.y - 100 / t.x - 160;
//  else
//    t.inc_y = 1000;
  t.inc_x *= 0.3;
  t.inc_y *= 0.3;
}

void InitStars()
{
  for (int i = 0; i < NUMSTARS; i++)
    InitStar(stars[i]);
}

void VertRet(void)
{
  asm
  {
    mov dx,03DAh
@1: in al,dx
    test al,8
    jz @1
@2: in al,dx
    test al,8
    jnz @2
  }
}

void main(int argc, char *argv[])
{
  int angle = 0;

  if (argc == 2)
  {
    NUMSTARS = atoi(argv[1]);
    if (NUMSTARS == 0 || NUMSTARS > 2000) NUMSTARS = 1000;
  }

  randomize();
  SetMode(0x13);
  InitStars();

  for (int i = 1; i < 63; i++)
    SetRGB(i, 0, i, i);

  do
  {
    for (int i = 0; i < NUMSTARS; i++)
    {
      PutPixel((int)stars[i].x, (int)stars[i].y, 0);
      stars[i].x += stars[i].inc_x;
      stars[i].y += stars[i].inc_y;
      stars[i].inc_x *= 1.03;
      stars[i].inc_y *= 1.03;
      if (stars[i].color < 62)
        stars[i].color += 0.6;
      if ((stars[i].x > 319) || (stars[i].y > 199) ||
          (stars[i].x < 0) || (stars[i].y < 0))
        InitStar(stars[i]);
      PutPixel((int)stars[i].x, (int)stars[i].y, (int)stars[i].color);
    }
    VertRet();
    angle++;
    if (angle > 359) angle = 0;
  } while (!kbhit());

  SetMode(0x03);
}
