#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

int NUMSTARS = 1000;
int a = 0;

struct TPoint {
  float r, angle, inc_r, color, x, y;
} stars[2000];

void SetMode(int mode)
{
  asm mov ax, mode
  asm int 10h
}

void SetRGB(unsigned char Color, unsigned char R, unsigned char G, unsigned char B)
{
  asm
  {
    mov  dx, 03C8h
    mov al, Color
    out  dx, al
    inc  dx
    mov  al, R
    out  dx, al
    mov  al, G
    out  dx, al
    mov  al, B
    out  dx, al
  }
}

void PutPixel(int x, int y, char color)
{
  asm
  {
    cmp x, 318
    ja @1
    cmp y, 198
    ja @1
    push es
    mov ax, 0A000h
    mov es, ax
    mov di, y
    shl di, 8
    mov bx, y
    shl bx, 6
    add di, bx
    add di, x
    mov al, color
    stosb
    stosb
    add di, 318
    stosb
    stosb
    pop es
@1:
  }
}

void InitStar(TPoint &t)
{
  t.r = random(200);
  t.angle = random(360);
  t.color = 0;
  t.inc_r = 0.5;
}

void InitStars()
{
  for (int i = 0; i < NUMSTARS; i++)
    InitStar(stars[i]);
}

void VertRet(void)
{
  asm
  {
    mov dx,03DAh
@1: in al,dx
    test al,8
    jz @1
@2: in al,dx
    test al,8
    jnz @2
  }
}

void main(int argc, char *argv[])
{
  int angle, inc_a = 1;

  if (argc == 2)
  {
    NUMSTARS = atoi(argv[1]);
    if (NUMSTARS == 0 || NUMSTARS > 2000) NUMSTARS = 1000;
  }

  randomize();
  SetMode(0x13);
  InitStars();

  for (int i = 1; i < 63; i++)
    SetRGB(i, 0, i, i);

  do
  {
    for (int i = 0; i < NUMSTARS; i++)
    {
      PutPixel((int)stars[i].x, (int)stars[i].y, 0);
      stars[i].r += stars[i].inc_r;
      stars[i].inc_r *= 1.01;
      stars[i].x = cos((stars[i].angle + angle) * M_PI / 180) * stars[i].r + 160;
      stars[i].y = sin((stars[i].angle + angle) * M_PI / 180) * stars[i].r + 100;
      if ((int)stars[i].color < 63)
        stars[i].color += 0.5;
      if ((stars[i].x > 319) || (stars[i].y > 319) ||
          (stars[i].x < 0) || (stars[i].y < -60))
        InitStar(stars[i]);
      PutPixel((int)stars[i].x, (int)stars[i].y, (int)stars[i].color);
    }
    VertRet();
    angle += inc_a;
    if (angle < 0)
    {
      angle = 0;
      inc_a = 1;
    }
    if (angle > 359)
    {
      angle = 359;
      inc_a = -1;
    }
  } while (!kbhit());

  SetMode(0x03);
}
